#include "strpool.h"

StrDef* StrPool::findString(const char *str) const {
    moveToBeg();
    while (pointerNext != 0) {
        if (strcmp(str, ((StrDef*) pointerNext)->str) == 0) {
            return ((StrDef*) pointerNext);
        }
        moveForward();
    }
    return 0;
}

const char* StrPool::addString(const char *str) {
    StrDef *s = findString(str);
    if (s != 0)
        return s->str;
    s = new StrDef(str);
    moveToBeg();
    insertBefore(s);
    return s->str;
}
